<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/hashbrown-0.12.3/src/raw/bitmask.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>bitmask.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../storage.js"></script><script defer src="../../../source-script.js"></script><script defer src="../../../source-files.js"></script><script defer src="../../../main.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../hashbrown/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../hashbrown/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../hashbrown/index.html"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident"><span class="kw">super</span>::imp</span>::{<span class="ident">BitMaskWord</span>, <span class="ident">BITMASK_MASK</span>, <span class="ident">BITMASK_STRIDE</span>};
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;nightly&quot;</span>)]</span>
<span class="kw">use</span> <span class="ident">core::intrinsics</span>;

<span class="doccomment">/// A bit mask which contains the result of a `Match` operation on a `Group` and</span>
<span class="doccomment">/// allows iterating through them.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The bit mask is arranged so that low-order bits represent lower memory</span>
<span class="doccomment">/// addresses for group match results.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// For implementation reasons, the bits in the set may be sparsely packed, so</span>
<span class="doccomment">/// that there is only one bit-per-byte used (the high bit, 7). If this is the</span>
<span class="doccomment">/// case, `BITMASK_STRIDE` will be 8 to indicate a divide-by-8 should be</span>
<span class="doccomment">/// performed on counts/indices to normalize this difference. `BITMASK_MASK` is</span>
<span class="doccomment">/// similarly a mask of all the actually-used bits.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Copy</span>, <span class="ident">Clone</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">BitMask</span>(<span class="kw">pub</span> <span class="ident">BitMaskWord</span>);

<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">clippy::use_self</span>)]</span>
<span class="kw">impl</span> <span class="ident">BitMask</span> {
    <span class="doccomment">/// Returns a new `BitMask` with all bits inverted.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="attribute">#[<span class="ident">must_use</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">invert</span>(<span class="self">self</span>) -&gt; <span class="self">Self</span> {
        <span class="ident">BitMask</span>(<span class="self">self</span>.<span class="number">0</span> <span class="op">^</span> <span class="ident">BITMASK_MASK</span>)
    }

    <span class="doccomment">/// Flip the bit in the mask for the entry at the given index.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Returns the bit&#39;s previous state.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">clippy::cast_ptr_alignment</span>)]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;raw&quot;</span>)]</span>
    <span class="kw">pub</span> <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">flip</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">index</span>: <span class="ident">usize</span>) -&gt; <span class="ident">bool</span> {
        <span class="comment">// NOTE: The + BITMASK_STRIDE - 1 is to set the high bit.</span>
        <span class="kw">let</span> <span class="ident">mask</span> <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> (<span class="ident">index</span> <span class="op">*</span> <span class="ident">BITMASK_STRIDE</span> <span class="op">+</span> <span class="ident">BITMASK_STRIDE</span> <span class="op">-</span> <span class="number">1</span>);
        <span class="self">self</span>.<span class="number">0</span> <span class="op">^</span><span class="op">=</span> <span class="ident">mask</span>;
        <span class="comment">// The bit was set if the bit is now 0.</span>
        <span class="self">self</span>.<span class="number">0</span> <span class="op">&amp;</span> <span class="ident">mask</span> <span class="op">==</span> <span class="number">0</span>
    }

    <span class="doccomment">/// Returns a new `BitMask` with the lowest bit removed.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="attribute">#[<span class="ident">must_use</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">remove_lowest_bit</span>(<span class="self">self</span>) -&gt; <span class="self">Self</span> {
        <span class="ident">BitMask</span>(<span class="self">self</span>.<span class="number">0</span> <span class="op">&amp;</span> (<span class="self">self</span>.<span class="number">0</span> <span class="op">-</span> <span class="number">1</span>))
    }
    <span class="doccomment">/// Returns whether the `BitMask` has at least one set bit.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">any_bit_set</span>(<span class="self">self</span>) -&gt; <span class="ident">bool</span> {
        <span class="self">self</span>.<span class="number">0</span> <span class="op">!</span><span class="op">=</span> <span class="number">0</span>
    }

    <span class="doccomment">/// Returns the first set bit in the `BitMask`, if there is one.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">lowest_set_bit</span>(<span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span> {
        <span class="kw">if</span> <span class="self">self</span>.<span class="number">0</span> <span class="op">==</span> <span class="number">0</span> {
            <span class="prelude-val">None</span>
        } <span class="kw">else</span> {
            <span class="prelude-val">Some</span>(<span class="kw">unsafe</span> { <span class="self">self</span>.<span class="ident">lowest_set_bit_nonzero</span>() })
        }
    }

    <span class="doccomment">/// Returns the first set bit in the `BitMask`, if there is one. The</span>
    <span class="doccomment">/// bitmask must not be empty.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;nightly&quot;</span>)]</span>
    <span class="kw">pub</span> <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">lowest_set_bit_nonzero</span>(<span class="self">self</span>) -&gt; <span class="ident">usize</span> {
        <span class="ident">intrinsics::cttz_nonzero</span>(<span class="self">self</span>.<span class="number">0</span>) <span class="kw">as</span> <span class="ident">usize</span> <span class="op">/</span> <span class="ident">BITMASK_STRIDE</span>
    }
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;nightly&quot;</span>))]</span>
    <span class="kw">pub</span> <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">lowest_set_bit_nonzero</span>(<span class="self">self</span>) -&gt; <span class="ident">usize</span> {
        <span class="self">self</span>.<span class="ident">trailing_zeros</span>()
    }

    <span class="doccomment">/// Returns the number of trailing zeroes in the `BitMask`.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">trailing_zeros</span>(<span class="self">self</span>) -&gt; <span class="ident">usize</span> {
        <span class="comment">// ARM doesn&#39;t have a trailing_zeroes instruction, and instead uses</span>
        <span class="comment">// reverse_bits (RBIT) + leading_zeroes (CLZ). However older ARM</span>
        <span class="comment">// versions (pre-ARMv7) don&#39;t have RBIT and need to emulate it</span>
        <span class="comment">// instead. Since we only have 1 bit set in each byte on ARM, we can</span>
        <span class="comment">// use swap_bytes (REV) + leading_zeroes instead.</span>
        <span class="kw">if</span> <span class="macro">cfg!</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;arm&quot;</span>) <span class="op">&amp;&amp;</span> <span class="ident">BITMASK_STRIDE</span> <span class="op">%</span> <span class="number">8</span> <span class="op">==</span> <span class="number">0</span> {
            <span class="self">self</span>.<span class="number">0</span>.<span class="ident">swap_bytes</span>().<span class="ident">leading_zeros</span>() <span class="kw">as</span> <span class="ident">usize</span> <span class="op">/</span> <span class="ident">BITMASK_STRIDE</span>
        } <span class="kw">else</span> {
            <span class="self">self</span>.<span class="number">0</span>.<span class="ident">trailing_zeros</span>() <span class="kw">as</span> <span class="ident">usize</span> <span class="op">/</span> <span class="ident">BITMASK_STRIDE</span>
        }
    }

    <span class="doccomment">/// Returns the number of leading zeroes in the `BitMask`.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">leading_zeros</span>(<span class="self">self</span>) -&gt; <span class="ident">usize</span> {
        <span class="self">self</span>.<span class="number">0</span>.<span class="ident">leading_zeros</span>() <span class="kw">as</span> <span class="ident">usize</span> <span class="op">/</span> <span class="ident">BITMASK_STRIDE</span>
    }
}

<span class="kw">impl</span> <span class="ident">IntoIterator</span> <span class="kw">for</span> <span class="ident">BitMask</span> {
    <span class="kw">type</span> <span class="ident">Item</span> <span class="op">=</span> <span class="ident">usize</span>;
    <span class="kw">type</span> <span class="ident">IntoIter</span> <span class="op">=</span> <span class="ident">BitMaskIter</span>;

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">into_iter</span>(<span class="self">self</span>) -&gt; <span class="ident">BitMaskIter</span> {
        <span class="ident">BitMaskIter</span>(<span class="self">self</span>)
    }
}

<span class="doccomment">/// Iterator over the contents of a `BitMask`, returning the indices of set</span>
<span class="doccomment">/// bits.</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">BitMaskIter</span>(<span class="ident">BitMask</span>);

<span class="kw">impl</span> <span class="ident">Iterator</span> <span class="kw">for</span> <span class="ident">BitMaskIter</span> {
    <span class="kw">type</span> <span class="ident">Item</span> <span class="op">=</span> <span class="ident">usize</span>;

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">next</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">bit</span> <span class="op">=</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">lowest_set_bit</span>()<span class="question-mark">?</span>;
        <span class="self">self</span>.<span class="number">0</span> <span class="op">=</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">remove_lowest_bit</span>();
        <span class="prelude-val">Some</span>(<span class="ident">bit</span>)
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="hashbrown" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>